<?php

require_once 'inc/regexfun.php';
require_once 'inc/wikiexpr.php';

/*

Handles conditions:

 [if:CONDITION] wiki code here [endif]

Conditions can be nested.

Conditions are actually PHP expressions with some restrictions:
No functions may be called or variables referenced.
Only a few constants are defined - they're interpreted
as calls to functions of the site.

*/


function WikiConditionProcess($n)
{
  $data = &$GLOBALS['WIKICONDITIONS'][$n];
  if(!$data) return '<unknown condition: '.$n.'>';
  $condition = $data['cond'];
  $text      = $data['text'];
  
  if($GLOBALS['WIKI_PARSER'] == WIKI_PARSING_NORMAL)
  {
    $error = '';
    $cond = WikiExpressionParse($condition, $error);
    if($error) return $error;
    if(!$cond) return '';
  }
  if($condition == '0') return '';
  return WikiConditionsComplete($text);
}

function WikiConditionSave($cond, $text)
{
  $n = count($GLOBALS['WIKICONDITIONS']);
  $GLOBALS['WIKICONDITIONS'][$n] = Array('cond'=>WikiUnescapeLink($cond),'text'=>$text);
  return '[wikicondition:'.$n++.']';
}

function WikiConditionsComplete($text)
{
  return preg_replace
  (
    '@\[wikicondition:([0-9]+)\]@e',
    'WikiConditionProcess(\\1)',
    $text
  );
}

function WikiConditionsProcess($text)
{
  $GLOBALS['WIKICONDITIONS'] = Array();
  $c1 = 0;
  for(;;)
  {
    $text = preg_replace
    (
      // Greedy is good.
      '@\[if:((?:]]|[^\]])*)\]('.CreateNonMatchRegexp('[if:').'*)\[endif\]@e',
      "WikiConditionSave(str_replace('\\\"', '\"', '\\1'),str_replace('\\\"', '\"', '\\2'))",
      $text
    );
    $c2 = count($GLOBALS['WIKICONDITIONS']);
    if($c2 == $c1) break;
    $c1 = $c2;
  }
  return WikiConditionsComplete($text);
}
