<?php

/* 
(?:[\w ,]+|(?:[[:alnum:]]+:|=)(?:\[\[|]]|[^ [\]])+)(?:|\|(?:\[\[|]]|[^[\]])*)
*/

define('WIKI_PARSING_NORMAL',   0);
define('WIKI_PARSING_LINKS',    1);
define('WIKI_PARSING_TEXT',     2);
define('WIKI_PARSING_SNAPSHOT', 3);

define('WIKI_URLS_LOCAL',    0);
define('WIKI_URLS_ABSOLUTE', 1);
define('WIKI_URLS_SNAPSHOT', 2);

$GLOBALS['WIKIREPLACES'] = Array
(
  '@[ \t]+$@S'
    => '',
  '@&@'
    => '&amp;',
  '@<@'
    => '&lt;',
  '@"@'
    => '&quot;',
  '@\[\[@'
    => '&#91;',
  '@\]\]@'
    => '&#93;',
  '@\[\|\]@'
    => '&#124;',
  '@\[\:\]@'
    => '&#58;',
  '@%%%%@'
    => '<br clear="all"/>',
  '@%%%@'
    => '<br/>',
  '@^----+$@e'
    => 'WikiCreateRuler()',
  '@^!!!! ?(.*)$@e'
    => "WikiCreateHeader(1, str_replace('\\\"', '\"', '\\1'))",
  '@^!!! ?(.*)$@e'
    => "WikiCreateHeader(2, str_replace('\\\"', '\"', '\\1'))",
  '@^!! ?(.*)$@e'
    => "WikiCreateHeader(3, str_replace('\\\"', '\"', '\\1'))",
  '@^!([a-z0-9 ].*)$@e'
    => "WikiCreateHeader(4, str_replace('\\\"', '\"', '\\1'))",
  "@''@Ue"
    => "WikiStoreConst('WikiToggleEmphasis','em')",
  '@__@Ue'
    => "WikiStoreConst('WikiToggleEmphasis','b')",
  '@(?<!-)---(?!-)@Ue'
    => "WikiStoreConst('WikiToggleEmphasis','strike')",
  '@««@Ue'
    => "WikiStoreConst('WikiEnterEmphasis','q')",
  '@»»@Ue'
    => "WikiStoreConst('WikiLeaveEmphasis','q')",
  '@\(\(@Ue'
    => "WikiStoreConst('WikiEnterEmphasis','small')",
  '@\)\)@Ue'
    => "WikiStoreConst('WikiLeaveEmphasis','small')",
  '@\{\{@Ue'
    => "WikiStoreConst('WikiEnterEmphasis','tt')",
  '@\}\}@Ue'
    => "WikiStoreConst('WikiLeaveEmphasis','tt')",
//  "@''(.*)''@Ue"
//    => "WikiEmphasisFunc(str_replace('\\\"', '\"', '\\1'), 'em')",
//  '@__(.*)__@Ue'
//    => "WikiEmphasisFunc(str_replace('\\\"', '\"', '\\1'), 'b')",
//  '@(?<!-)---([^-](?:.*[^-])*)---(?!-)@Ue'
//    => "WikiEmphasisFunc(str_replace('\\\"', '\"', '\\1'), 'strike')",
  '@\[#([1-9][0-9]*)\]@e'
    => "WikiCreateReference(\\1)",
  '@\[([1-9][0-9]*)\]@e'
    => "WikiCreateFootNote(\\1)",

  # Manual links
  '@\[((?:[/\w ,\'!-]+|(?:[[:alnum:]]+:|=)(?:\[\[|]]|[^[\]])+)(?:|\|(?:\[\[|]]|[^[\]])*))\]@e' // \w matches alphanumeric minus _
    => "WikiStoreDyn('WikiLinkFunc',str_replace('\\\"', '\"', '\\1'))",

#  # Disabled AutoLinks
#  '@!([A-Za-z][A-Za-z0-9_]*)@e'
#    => "WikiStoreDyn('WikiIdleFunc',str_replace('\\\"', '\"', '\\1'))",
#  
#  # AutoLinks: begins with capital (no preceding a-z0-9 context)
#  #            continues with at least 1 of a-z0-9, but must contain at least 1 a-z
#  #            continues with capital, and eat the rest of the word.
#  '@((?<![a-z0-9])[A-Z]+[a-z0-9]*[a-z][a-z0-9]*[A-Z][A-Za-z0-9]*)@eS'
#    => "WikiStoreDyn('WikiLinkFuncFT',str_replace('\\\"', '\"', '\\1'))",
  
  # Disabled AutoUrls
  '!((?:(?:git|https?)://(?:(?:[[:alnum:]](?:[[:alnum:]-]*[[:alnum:]])?\.)*[[:alpha:]](?:[[:alnum:]-]*[[:alnum:]])?|[\d]+(?:\.[\d]+){3})(?::[\d]+)?(?:/(?:%[[:xdigit:]]{2}|[\w!$&-.:;=@~])*(?:/(?:%[[:xdigit:]]{2}|[\w!$&-.:;=@])*)*(?:\?(?:%[[:xdigit:]]{2}|[\w!$&-.:;=@])*)?)?|ftp://(?:(?:%[[:xdigit:]]{2}|[\w!$&-.;=?])*(?::(?:%[[:xdigit:]]{2}|[\w!$&-.;=?])*)?@)?(?:(?:[[:alnum:]](?:[[:alnum:]-]*[[:alnum:]])?\.)*[[:alpha:]](?:[[:alnum:]-]*[[:alnum:]])?|[\d]+(?:\.[\d]+){3})(?::[\d]+)?(?:/(?:%[[:xdigit:]]{2}|[\w!$&-.:=?@])*(?:/(?:%[[:xdigit:]]{2}|[\w!$&-.:=?@])*)*(?:;type=[ADIadi])?)?|news:(?:(?:%[[:xdigit:]]{2}|[\w!$&-/:;=?])+@(?:(?:[[:alnum:]](?:[[:alnum:]-]*[[:alnum:]])?\.)*[[:alpha:]](?:[[:alnum:]-]*[[:alnum:]])?|[\d]+(?:\.[\d]+){3})|[[:alpha:]][\w-+.]*|\*)|telnet://(?:(?:%[[:xdigit:]]{2}|[\w!$&-.;=?])*(?::(?:%[[:xdigit:]]{2}|[\w!$&-.;=?])*)?@)?(?:(?:[[:alnum:]](?:[[:alnum:]-]*[[:alnum:]])?\.)*[[:alpha:]](?:[[:alnum:]-]*[[:alnum:]])?|[\d]+(?:\.[\d]+){3})(?::[\d]+)?/?|mailto:(?:%[[:xdigit:]]{2}|[\w!$&-/:;=?@])+))eS'
    => "WikiStoreConst('WikiIdleFunc',str_replace('\\\"', '\"', '\\1'))",
  
  # AutoUrls
  '((?:(?:git|https?)://(?:(?:[[:alnum:]](?:[[:alnum:]-]*[[:alnum:]])?\.)*[[:alpha:]](?:[[:alnum:]-]*[[:alnum:]])?|[\d]+(?:\.[\d]+){3})(?::[\d]+)?(?:/(?:%[[:xdigit:]]{2}|[\w!$&-.:;=@~])*(?:/(?:%[[:xdigit:]]{2}|[\w!$&-.:;=@])*)*(?:\?(?:%[[:xdigit:]]{2}|[\w!$&-.:;=@])*)?)?|ftp://(?:(?:%[[:xdigit:]]{2}|[\w!$&-.;=?])*(?::(?:%[[:xdigit:]]{2}|[\w!$&-.;=?])*)?@)?(?:(?:[[:alnum:]](?:[[:alnum:]-]*[[:alnum:]])?\.)*[[:alpha:]](?:[[:alnum:]-]*[[:alnum:]])?|[\d]+(?:\.[\d]+){3})(?::[\d]+)?(?:/(?:%[[:xdigit:]]{2}|[\w!$&-.:=?@])*(?:/(?:%[[:xdigit:]]{2}|[\w!$&-.:=?@])*)*(?:;type=[ADIadi])?)?|news:(?:(?:%[[:xdigit:]]{2}|[\w!$&-/:;=?])+@(?:(?:[[:alnum:]](?:[[:alnum:]-]*[[:alnum:]])?\.)*[[:alpha:]](?:[[:alnum:]-]*[[:alnum:]])?|[\d]+(?:\.[\d]+){3})|[[:alpha:]][\w-+.]*|\*)|telnet://(?:(?:%[[:xdigit:]]{2}|[\w!$&-.;=?])*(?::(?:%[[:xdigit:]]{2}|[\w!$&-.;=?])*)?@)?(?:(?:[[:alnum:]](?:[[:alnum:]-]*[[:alnum:]])?\.)*[[:alpha:]](?:[[:alnum:]-]*[[:alnum:]])?|[\d]+(?:\.[\d]+){3})(?::[\d]+)?/?|mailto:(?:%[[:xdigit:]]{2}|[\w!$&-/:;=?@])+))eS'
    => "WikiStoreDyn('WikiLinkFuncFT',str_replace('\\\"', '\"', '\\1'))"
);

/*

Explanation of the wikilinkfunc regexp:

Two parts.

First part:
   any wikiword, possibly including [ ,'!/-]
or [a-zA-Z0-9]+: followed with anything but spaces or [ or ] ([[ and ]] are allowed)
or = followed with anything but spaces or [ or ] ([[ and ]] are allowed)

Second part:
   empty
or | followed by anything but [ or ] ([[ and ]] are allowed)

*/
