<?php

require_once 'inc/wikifun.php';

$GLOBALS['TABDATA'] = Array();
define('TABDATA_HID_NAME_PREFIX', '__%a'); // note: length must be same as in substr below
function WikiTabSave($title, $htmlcontent)
{
  $tabdata = &$GLOBALS['TABDATA'];
  
  if(!$title) $title = TABDATA_HID_NAME_PREFIX.count($tabdata);
  
  $tabdata[$title] = $htmlcontent;
  return '';
}

function WikiTabsComplete($shape='vert')
{
  $tabdata = &$GLOBALS['TABDATA'];
  
  $mainclass=    "tabber_{$shape}";
  $mainclasslive="tabber_{$shape}_live";
  
  /* Note: publishfun.php wants a mechanism to make all tabs displayed. */
  $result = "<div id=\"tabber\" class=\"$mainclass\">";
  
  foreach($tabdata as $title => $htmlcontent)
    $result .=
    (
      substr($title,0,4) == TABDATA_HID_NAME_PREFIX
        ? '<div class="tabbertab">'
        : '<div class="tabbertab" title="'.htmlspecialchars($title).'">'
    ). "$htmlcontent</div>";
  
  $result .= '</div><div class="clear"></div>';
  
  $options = "{classMain:'$mainclass',classMainLive:'$mainclasslive'}";
  $result .= WikiEmbedJavascript("tabberAutomatic($options)", false);

  $tabdata = Array();
  return $result;
}

function WikiTabsProcess($text)
{
  $tabdata = &$GLOBALS['TABDATA'];
  $tabdata = Array();
  
  return preg_replace(
    Array(
      "@%%TAB +(.*)(?:%%)?\r?\n(.*)(?=%%TAB(?: |_[HV]?END))@esU",
      "@%%TAB_V?END(?:%%)?\r?\n@e",
      "@%%TAB_HEND(?:%%)?\r?\n@e"
    ),
    Array(
      "WikiTabSave(str_replace('\\\"', '\"', '\\1'),str_replace('\\\"', '\"', '\\2'))",
      'WikiTabsComplete("vert")',
      'WikiTabsComplete("horiz")'
    ),
    $text);
}
