<?php

/* Note: This variable is saved and restored in WikiTextToHTML() */
$GLOBALS['toc_headers'] = Array();

function WikiTOCregisterHeader(&$anchor, $level, $label, $label_fixed)
{
  $anchor = preg_replace('/(&[^;]*;|[^a-z0-9])+/', '_', strtolower(strip_tags($label_fixed)));
  $anchor = preg_replace('/_*$/', '', $anchor); // remove trailing _
  $anchor = preg_replace('/^_*$/', '', $anchor); // remove heading _
  $anchor = preg_replace('/__*/', '_', $anchor); // remove many _
  $anchor = preg_replace('@^ *(.*[^ ]) *$@', '\1',
    preg_replace('@ +(/?) ?([a-zA-Z])@e', "'\\1'.strtoupper('\\2')",
      ' ' . str_replace('_', ' ', $anchor)
                )); // convert to CamelCase
  $anchor = trim($anchor); // remove extra spaces
  
  $toc_headers = &$GLOBALS['toc_headers'];
  
  $anchor_without_the = preg_replace('@^(?:The|A)([A-Z])@', '\1', $anchor);
  
  if(!isset($toc_headers[$anchor_without_the]))
    $anchor = $anchor_without_the;
  
  $suffix = '';
  $suffixnr = 1;
  // Make unique
  while(isset($toc_headers[$anchor.$suffix]))
    $suffix = '_' . ++$suffixnr;
  $anchor .= $suffix;
  
  if($level != 1) // ignore top-level header
    $toc_headers[$anchor] = Array
    (
      'level'=>$level,
      'anchor'=>$anchor,
      'label'=>$label,
      'label_fixed'=>$label_fixed
    );
}

function WikiCreateTOC($params)
{
  static $tocidx=0;
  ++$tocidx;
  $tocid = "wikitoc$tocidx";
  
  $min_open_level = 0;
  if(isset($params['open']))
    $min_open_level = (int)$params['open'];
  
  $toc_headers = $GLOBALS['toc_headers'];
  $GLOBALS['toc_headers'] = Array();
  
  $result = '<div class="toc">';
  $result .= 'Table of contents';
  
  $js = "expandTree('$tocid')";
  $result .= ' [<span onclick="'.htmlspecialchars($js).'" class="mktreecmd">expand all</span>]';
  $js = "collapseTree('$tocid')";
  $result .= ' [<span onclick="'.htmlspecialchars($js).'" class="mktreecmd">collapse all</span>]';
  
  $result .= '<br/>';

  $minlevel=99;
  $counts = Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
  foreach($toc_headers as $item)
    $minlevel=min($minlevel, $item['level']);
  foreach($toc_headers as $item) ++$counts[$item['level']];
  
  ksort($counts);
  
  $li = Array();
  $sum = $counts[0];
  foreach($counts as $level => $count)
  {
    $sum += $counts[$level+1];
    if(($sum < 20 && $min_open_level >= 0)
    || $level <= $min_open_level
      )
      @$li[$level - $minlevel + 1] = '<li class="liOpen">';
    else
      @$li[$level - $minlevel + 1] = '<li>';
    
    if($level >= 15) break; // avoids warning of undefined array index.
  }
  
  $l=0;
  $lop=0; $lopnow=0;
  $ul = "\n" . '<ul class="mktree" id="'.$tocid.'">';
  foreach($toc_headers as $item)
  {
    $l2 = $item['level'] - $minlevel + 1;
    
    while($l2 > $l) { ++$l; $result .= $ul.$li[$l]; ++$lop; $lopnow=0;
                      $ul = '<ul>';
                    }
    while($l2 < $l) { $result .= '</li></ul>'; --$l; --$lop; $lopnow=1; }
    
    if($lopnow) { $result .= '</li>'.$li[$l2]; }
    $result  .= '<a href="#'. $item['anchor']. '">';
     $label  = $item['label_fixed'];
    $result  .= $label;
    $result  .= '</a>';
    $lopnow=1;
  }
  while(0 < $l) { $result .= '</li></ul>'; --$l; --$lop; }
  
  $result .= '</div>';
  
  return WikiEmphasisTransition($result);
}

function WikiProcessTOC($result)
{
  return preg_replace('@%%TOC([^%]*)%%@e',
    "WikiBuiltInModuleDoExec('WikiCreateTOC', str_replace('\\\"', '\"', '\\1'))",
    $result);
}
